/* $Id: cpl_dfs.h,v 1.9 2007/10/23 11:38:05 llundin Exp $
 *
 * This file is part of the IIINSTRUMENT Pipeline
 * Copyright (C) 2002,2003 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: llundin $
 * $Date: 2007/10/23 11:38:05 $
 * $Revision: 1.9 $
 * $Name: cpl-4_1_0 $
 */

#ifndef CPL_DFS_H
#define CPL_DFS_H

#include <cpl_imagelist.h>
#include <cpl_table.h>
#include <cpl_frameset.h>
#include <cpl_propertylist.h>
#include <cpl_parameterlist.h>
#include <cpl_error.h>

CPL_BEGIN_DECLS

/*-----------------------------------------------------------------------------
                                 Defines
 -----------------------------------------------------------------------------*/

#define CPL_DFS_FITS ".fits"
#define CPL_DFS_PAF ".paf"

/*-----------------------------------------------------------------------------
                              Function prototypes
 -----------------------------------------------------------------------------*/

cpl_error_code cpl_dfs_save_image(cpl_frameset *,
                                  const cpl_parameterlist *,
                                  const cpl_frameset *,
                                  const cpl_image *,
                                  cpl_type_bpp,
                                  const char *,
                                  const char *,
                                  const cpl_propertylist *,
                                  const char *,
                                  const char *,
                                  const char *);

cpl_error_code cpl_dfs_save_imagelist(cpl_frameset *,
                                      const cpl_parameterlist *,
                                      const cpl_frameset *,
                                      const cpl_imagelist *,
                                      cpl_type_bpp,
                                      const char *,
                                      const char *,
                                      const cpl_propertylist *,
                                      const char *,
                                      const char *,
                                      const char *);

cpl_error_code cpl_dfs_save_table(cpl_frameset *,
                                  const cpl_parameterlist *,
                                  const cpl_frameset *,
                                  const cpl_table *,
                                  const cpl_propertylist *,
                                  const char *,
                                  const char *,
                                  const cpl_propertylist *,
                                  const char *,
                                  const char *,
                                  const char *);

cpl_error_code cpl_dfs_save_paf(const char *, const char *,
                                const cpl_propertylist *, const char *);

cpl_error_code cpl_dfs_setup_product_header(cpl_propertylist *, 
                                            const cpl_frame *, 
                                            const cpl_frameset *, 
                                            const cpl_parameterlist *, 
                                            const char *,
                                            const char *,
                                            const char *);

cpl_error_code cpl_dfs_update_product_header(cpl_frameset *);

CPL_END_DECLS

#endif
